#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class Api::V6::ActivitiesController < Api::V5::ActivitiesController

  # Return all the activities as per requested criteria
  def index

    query_condition = generate_query(params)

    # Get requested response limits or set a limit
    limit = params.has_key?(:limit) ? params[:limit] : 50

    activities = Activity.where(query_condition).sort(:time_created.desc).limit(limit)

    render json: { activities: activities.all }, status: :ok
  rescue ArgumentError, SyntaxError, JSON::ParserError, NoMethodError, TypeError => ex
    logger.error(ex)
    render json: { :error => ex.class.to_s+': '+ex.message }, status: 400
  end

end
