#
# Copyright 2015 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

require 'savon'

DEBUG = false

# The installer uses this, in order, so be careful how you insert things
VALID_ROLES = [:rabbitmq, :mongodb, :nginx, :orchestrate]
GENERATED_PASSWORD_LENGTH = 32
COLLABNET_REPOSITORY_NAME = 'CollabNet-Orchestrate'
COLLABNET_DIR = File.join('/opt', 'collabnet')
RUBY_HOME_DIR = File.join(COLLABNET_DIR, 'ruby')
ORCHESTRATE_HOME_DIR = File.join(COLLABNET_DIR, 'orchestrate')

SYSTEM_INITD_DIR = File.join('/etc', 'init.d')
SYSTEM_LOGROTATE_DIR = File.join('/etc', 'logrotate.d')

TEAMFORGE_APP_NAME = 'TeamForge'

ORCHESTRATE_DEFAULTS_YAML_FILE = File.join(ORCHESTRATE_HOME_DIR, 'config', 'defaults.yml')
ORCHESTRATE_SITE_OPTIONS_FILE = File.join(ORCHESTRATE_HOME_DIR, 'config', 'site-options.conf')
ORCHESTRATE_LOCAL_OPTIONS_FILE = File.join(ORCHESTRATE_HOME_DIR, 'config', 'templates', 'site-options-local.conf')

ORCHESTRATE_INSTALLER_ROOT_SSH_KEY_FILE = File.expand_path('~/.ssh/orchestrate_installer')
ORCHESTRATE_INSTALLER_ROOT_PUBKEY_FILE = File.expand_path('~/.ssh/orchestrate_installer.pub')
ORCHESTRATE_INSTALLER_AUTHORIZED_KEYS_FILE = File.expand_path('~/.ssh/authorized_keys')

ORCHESTRATE_USER = 'orchestrate'
ORCHESTRATE_NAME = 'TeamForge Orchestrate'
ORCHESTRATE_SERVICES_USER = 'orchestrate'
ORCHESTRATE_TMP_SECRET_TOKEN = '/tmp/secret_token.rb'
ORCHESTRATE_SERVICE_PORT = '8844'

# Base directory containing all of the installer's generated config files, marker files, and site options:
INSTALLER_BASE_DIR = File.join(ORCHESTRATE_HOME_DIR, 'tmp', 'installer')
# Path to the config file use as mechanisms for the capistrano module to read
# information gathered during the frontend questions/answers:
INSTALLER_YAML_CONFIG_FILE = File.join(INSTALLER_BASE_DIR, 'installer.yml')
# Path to location of installer state markers:
INSTALLER_MARKER_DIR = File.join(INSTALLER_BASE_DIR, 'installer_tasks')
# Path to the generated site options file, representing the values from the last run of the installer:
INSTALLER_LAST_OPTIONS_FILE = File.join(INSTALLER_BASE_DIR, 'last-site-options.conf')

BACKUP_TIMESTAMP_FORMAT = '%Y%d%m%H%M%S'

# RabbitMQ section
RABBITMQ_HOME_DIR = File.join(COLLABNET_DIR, 'rabbitmq')
RABBITMQ_PASSWORDS_FILE = File.join(RABBITMQ_HOME_DIR, '.rabbit_passwords')
RABBITMQ_USER = 'collabnet-rabbitmq'
RABBITMQ_ADMIN = 'guest'

# MongoDB
MONGODB_HOME_DIR = File.join(COLLABNET_DIR, 'mongodb')
MONGODB_PASSWORDS_FILE = File.join(MONGODB_HOME_DIR, '.mongo_passwords')
MONGODB_USER = 'collabnet-mongodb'
MONGODB_ADMIN_DB_NAME = 'admin'
MONGODB_ADMIN_DB_USER = 'admin'
MONGODB_BACKUP_DB_USER = 'backup'
MONGODB_ORCHESTRATE_DB_NAME = 'orchestrate'

# Nginx section
NGINX_HOME_DIR = File.join(COLLABNET_DIR, 'nginx')
NGINX_CONFIG_FILE = File.join(NGINX_HOME_DIR, 'conf', 'collabnet-nginx.conf')
NGINX_USER = 'collabnet-nginx'


#Sets logging level for Savon
#TODO - Ask EP why they are set
Savon.configure do |config|
  config.log = false
  config.log_level = :error
  config.logger = false
end

#Sets logging level for HTTPI
HTTPI.logger = false
HTTPI.log_level = :error
HTTPI.log = false
