#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

default_run_options[:pty] = true

namespace :orchestrate do
  before 'orchestrate:rabbitmq:install', 'validate'
  before 'orchestrate:rabbitmq:upgrade', 'validate'
  before 'orchestrate:rabbitmq:clean_reinstall', 'validate'

  before 'orchestrate:mongodb:install', 'validate'
  before 'orchestrate:mongodb:upgrade', 'validate'
  before 'orchestrate:mongodb:clean_reinstall', 'validate'

  before 'orchestrate:nginx:install', 'validate'
  before 'orchestrate:nginx:upgrade', 'validate'
  before 'orchestrate:nginx:clean_reinstall', 'validate'

  before 'orchestrate:orchestrate:install', 'validate'
  before 'orchestrate:orchestrate:upgrade', 'validate'
  before 'orchestrate:orchestrate:clean_reinstall', 'validate'
  before 'orchestrate:orchestrate:check_prefix_availability', 'validate'
end

task :validate do
  installer.load_installer_yaml_config(INSTALLER_YAML_CONFIG_FILE)
  installer.validate_role
  installer.validate_ssh_hosts
  installer.validate_rpm_repo
  installer.validate_ssh_user
  installer.validate_credentials

  # validation is now good so setting role and server
  role fetch(:role), fetch(:ssh_hosts)
end

#Add /sbin to capistrano's ssh path for chkconfig and runuser
set :default_environment, {
    'PATH' => "/sbin:$PATH"
}
