#
# Copyright 2013 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

namespace :orchestrate do
  namespace :orchestrate do

    desc 'Install Orchestrate app server'
    task :install, :roles => :orchestrate do
      app_server.setup(:install)
    end

    desc 'ReInstall Orchestrate app server'
    task :clean_reinstall, :roles => :orchestrate do
      app_server.stop
      app_server.setup(:clean_reinstall)
    end


    desc 'Upgrade the RPM packages for Orchestrate'
    task :upgrade, :roles => :orchestrate do
      app_server.stop
      yum.update('collabnet-orchestrate-core')
      app_server.start
    end

    desc 'Check for Orchestrate prefixes in TeamForge'
    task :check_prefix_availability do
      app_server.validate
    end
  end
end