require 'yaml'

# a task namespace to help support orchestrate
namespace :dev do
  desc 'Setup orchestrate'
  task :setup => :environment do

    puts "Setting Indexes"
    Rake::Task["db:index"].invoke

    puts "Running Migrations"
    Rake::Task["db:migrate"].invoke
   
    puts "Registering site wide linked app"
    linked_app_id = CtfConfigurer.new.create_site_wide_linked_application
    config_file = 'config/user/vagrant.yml'
    user_config = YAML.load_file config_file
    user_config['teamforge']['development']['linked_app_id'] = linked_app_id.to_s
    File.open(config_file, 'w') { |file| file.write user_config.to_yaml}
 
    puts "Please start Orchestrate with 'sudo systemctl start orchestrate.target'"
    puts "And then run 'bundle exec rake dev:register' to register IAF from orchestrate to teamforge"
  end

  desc 'Register Orchestrates IAF with teamforge'
  task :register => :environment do

    raise 'Orchestrate is not started, aborting registration' unless File.exists? 'tmp/pids/server.pid'

    puts "Registering IAF..."
    CtfConfigurer.new.create_iaf_application

  end
end
