#
# Copyright 2016 CollabNet, Inc. All rights reserved. Usage governed by the LICENSE.txt file.
#

class CtfInterpolations

  # Provide a hash of interpolation tokens and their runtime values.
  #
  # @return [Hash] Hash of token => url.
  def self.interpolation_table
    ctf_base_url = Rails.configuration.teamforge[:server]
    ctf_go_url = URI.join(ctf_base_url, "/sf/go").to_s
    {
        '%CTF_BASE_URL%' => ctf_base_url,
        '%CTF_GO_URL%' => ctf_go_url
    }
  end

  # Interpolate all the ctf tokens found in a string to their runtime values.
  #
  # @param [String] text String to search for tokens
  # @return [String] Interpolated text.
  def self.interpolate_ctf_tokens(text)
    result = text.to_s
    interpolation_table.each do |key, value|
      result.gsub!(key, value)
    end
    result
  end

end
