class WorkItemIntegrationUtils
  include RabbitServices

  def initialize
    setup_config
  end

  def create_tracker_source(project_configuration)
    # project = project_configuration.project
    # tracker_source = TrackerSource.new(project: project_configuration.project,
    #                                    display_name: project.name,
    #                                    source_association_key: UUID.generate,
    #                                    queue_username: project.name.parameterize.underscore + '_rabbit_user',
    #                                    queue_password: SecureRandom.hex(32).to_s)
    # project_configuration.tracker_source = tracker_source
    # if tracker_source.save && project_configuration.save && create_queue_account(tracker_source.queue_username, tracker_source.queue_password)
    #   tracker_source
    # else
    #   logger.error("Could not create tracker source for the following project : #{Project.name}. Check the queue configuration; contact your network administrator for help.")
    #   tracker_source.delete
    #   project_configuration.update_attributes(tracker_source: nil)
    #   nil
    # end
  end

  def logger
    Rails.logger
  end

  # for upgraded version of Orchestrate will schedule a Resque job to create ctf tracker sources for ctf projects that
  # don't have one.
  class Upgrader
    @queue = :ctf_association_job

    def self.perform
      CtfConfigurer.new.edit_iaf_application
      TeamForge::ProjectConfiguration.where(tracker_source_id: nil).each do |project_configuration|
          WorkItemIntegrationUtils.new.create_tracker_source(project_configuration)
          OrchestrateSyncListenerService.new.send_world_state_message(project_configuration.ctf_project_id)
      end
    end
  end
end